// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from dynamic_graph_bridge_msgs:msg/Vector.idl
// generated code does not contain a copyright notice
#include "dynamic_graph_bridge_msgs/msg/detail/vector__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `data`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
dynamic_graph_bridge_msgs__msg__Vector__init(dynamic_graph_bridge_msgs__msg__Vector * msg)
{
  if (!msg) {
    return false;
  }
  // data
  if (!rosidl_runtime_c__double__Sequence__init(&msg->data, 0)) {
    dynamic_graph_bridge_msgs__msg__Vector__fini(msg);
    return false;
  }
  return true;
}

void
dynamic_graph_bridge_msgs__msg__Vector__fini(dynamic_graph_bridge_msgs__msg__Vector * msg)
{
  if (!msg) {
    return;
  }
  // data
  rosidl_runtime_c__double__Sequence__fini(&msg->data);
}

bool
dynamic_graph_bridge_msgs__msg__Vector__are_equal(const dynamic_graph_bridge_msgs__msg__Vector * lhs, const dynamic_graph_bridge_msgs__msg__Vector * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // data
  if (!rosidl_runtime_c__double__Sequence__are_equal(
      &(lhs->data), &(rhs->data)))
  {
    return false;
  }
  return true;
}

bool
dynamic_graph_bridge_msgs__msg__Vector__copy(
  const dynamic_graph_bridge_msgs__msg__Vector * input,
  dynamic_graph_bridge_msgs__msg__Vector * output)
{
  if (!input || !output) {
    return false;
  }
  // data
  if (!rosidl_runtime_c__double__Sequence__copy(
      &(input->data), &(output->data)))
  {
    return false;
  }
  return true;
}

dynamic_graph_bridge_msgs__msg__Vector *
dynamic_graph_bridge_msgs__msg__Vector__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dynamic_graph_bridge_msgs__msg__Vector * msg = (dynamic_graph_bridge_msgs__msg__Vector *)allocator.allocate(sizeof(dynamic_graph_bridge_msgs__msg__Vector), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(dynamic_graph_bridge_msgs__msg__Vector));
  bool success = dynamic_graph_bridge_msgs__msg__Vector__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
dynamic_graph_bridge_msgs__msg__Vector__destroy(dynamic_graph_bridge_msgs__msg__Vector * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    dynamic_graph_bridge_msgs__msg__Vector__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
dynamic_graph_bridge_msgs__msg__Vector__Sequence__init(dynamic_graph_bridge_msgs__msg__Vector__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dynamic_graph_bridge_msgs__msg__Vector * data = NULL;

  if (size) {
    data = (dynamic_graph_bridge_msgs__msg__Vector *)allocator.zero_allocate(size, sizeof(dynamic_graph_bridge_msgs__msg__Vector), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = dynamic_graph_bridge_msgs__msg__Vector__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        dynamic_graph_bridge_msgs__msg__Vector__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
dynamic_graph_bridge_msgs__msg__Vector__Sequence__fini(dynamic_graph_bridge_msgs__msg__Vector__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      dynamic_graph_bridge_msgs__msg__Vector__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

dynamic_graph_bridge_msgs__msg__Vector__Sequence *
dynamic_graph_bridge_msgs__msg__Vector__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dynamic_graph_bridge_msgs__msg__Vector__Sequence * array = (dynamic_graph_bridge_msgs__msg__Vector__Sequence *)allocator.allocate(sizeof(dynamic_graph_bridge_msgs__msg__Vector__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = dynamic_graph_bridge_msgs__msg__Vector__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
dynamic_graph_bridge_msgs__msg__Vector__Sequence__destroy(dynamic_graph_bridge_msgs__msg__Vector__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    dynamic_graph_bridge_msgs__msg__Vector__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
dynamic_graph_bridge_msgs__msg__Vector__Sequence__are_equal(const dynamic_graph_bridge_msgs__msg__Vector__Sequence * lhs, const dynamic_graph_bridge_msgs__msg__Vector__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!dynamic_graph_bridge_msgs__msg__Vector__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
dynamic_graph_bridge_msgs__msg__Vector__Sequence__copy(
  const dynamic_graph_bridge_msgs__msg__Vector__Sequence * input,
  dynamic_graph_bridge_msgs__msg__Vector__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(dynamic_graph_bridge_msgs__msg__Vector);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    dynamic_graph_bridge_msgs__msg__Vector * data =
      (dynamic_graph_bridge_msgs__msg__Vector *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!dynamic_graph_bridge_msgs__msg__Vector__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          dynamic_graph_bridge_msgs__msg__Vector__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!dynamic_graph_bridge_msgs__msg__Vector__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
