// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from dynamic_graph_bridge_msgs:srv/RunCommand.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "dynamic_graph_bridge_msgs/srv/run_command.hpp"


#ifndef DYNAMIC_GRAPH_BRIDGE_MSGS__SRV__DETAIL__RUN_COMMAND__STRUCT_HPP_
#define DYNAMIC_GRAPH_BRIDGE_MSGS__SRV__DETAIL__RUN_COMMAND__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__dynamic_graph_bridge_msgs__srv__RunCommand_Request __attribute__((deprecated))
#else
# define DEPRECATED__dynamic_graph_bridge_msgs__srv__RunCommand_Request __declspec(deprecated)
#endif

namespace dynamic_graph_bridge_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct RunCommand_Request_
{
  using Type = RunCommand_Request_<ContainerAllocator>;

  explicit RunCommand_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->input = "";
    }
  }

  explicit RunCommand_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : input(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->input = "";
    }
  }

  // field types and members
  using _input_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _input_type input;

  // setters for named parameter idiom
  Type & set__input(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->input = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    dynamic_graph_bridge_msgs::srv::RunCommand_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const dynamic_graph_bridge_msgs::srv::RunCommand_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dynamic_graph_bridge_msgs::srv::RunCommand_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dynamic_graph_bridge_msgs::srv::RunCommand_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dynamic_graph_bridge_msgs::srv::RunCommand_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dynamic_graph_bridge_msgs::srv::RunCommand_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dynamic_graph_bridge_msgs::srv::RunCommand_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dynamic_graph_bridge_msgs::srv::RunCommand_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dynamic_graph_bridge_msgs::srv::RunCommand_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dynamic_graph_bridge_msgs::srv::RunCommand_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dynamic_graph_bridge_msgs__srv__RunCommand_Request
    std::shared_ptr<dynamic_graph_bridge_msgs::srv::RunCommand_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dynamic_graph_bridge_msgs__srv__RunCommand_Request
    std::shared_ptr<dynamic_graph_bridge_msgs::srv::RunCommand_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RunCommand_Request_ & other) const
  {
    if (this->input != other.input) {
      return false;
    }
    return true;
  }
  bool operator!=(const RunCommand_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RunCommand_Request_

// alias to use template instance with default allocator
using RunCommand_Request =
  dynamic_graph_bridge_msgs::srv::RunCommand_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace dynamic_graph_bridge_msgs


#ifndef _WIN32
# define DEPRECATED__dynamic_graph_bridge_msgs__srv__RunCommand_Response __attribute__((deprecated))
#else
# define DEPRECATED__dynamic_graph_bridge_msgs__srv__RunCommand_Response __declspec(deprecated)
#endif

namespace dynamic_graph_bridge_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct RunCommand_Response_
{
  using Type = RunCommand_Response_<ContainerAllocator>;

  explicit RunCommand_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->result = "";
      this->standardoutput = "";
      this->standarderror = "";
    }
  }

  explicit RunCommand_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result(_alloc),
    standardoutput(_alloc),
    standarderror(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->result = "";
      this->standardoutput = "";
      this->standarderror = "";
    }
  }

  // field types and members
  using _result_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _result_type result;
  using _standardoutput_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _standardoutput_type standardoutput;
  using _standarderror_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _standarderror_type standarderror;

  // setters for named parameter idiom
  Type & set__result(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->result = _arg;
    return *this;
  }
  Type & set__standardoutput(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->standardoutput = _arg;
    return *this;
  }
  Type & set__standarderror(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->standarderror = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    dynamic_graph_bridge_msgs::srv::RunCommand_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const dynamic_graph_bridge_msgs::srv::RunCommand_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dynamic_graph_bridge_msgs::srv::RunCommand_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dynamic_graph_bridge_msgs::srv::RunCommand_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dynamic_graph_bridge_msgs::srv::RunCommand_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dynamic_graph_bridge_msgs::srv::RunCommand_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dynamic_graph_bridge_msgs::srv::RunCommand_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dynamic_graph_bridge_msgs::srv::RunCommand_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dynamic_graph_bridge_msgs::srv::RunCommand_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dynamic_graph_bridge_msgs::srv::RunCommand_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dynamic_graph_bridge_msgs__srv__RunCommand_Response
    std::shared_ptr<dynamic_graph_bridge_msgs::srv::RunCommand_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dynamic_graph_bridge_msgs__srv__RunCommand_Response
    std::shared_ptr<dynamic_graph_bridge_msgs::srv::RunCommand_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RunCommand_Response_ & other) const
  {
    if (this->result != other.result) {
      return false;
    }
    if (this->standardoutput != other.standardoutput) {
      return false;
    }
    if (this->standarderror != other.standarderror) {
      return false;
    }
    return true;
  }
  bool operator!=(const RunCommand_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RunCommand_Response_

// alias to use template instance with default allocator
using RunCommand_Response =
  dynamic_graph_bridge_msgs::srv::RunCommand_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace dynamic_graph_bridge_msgs


// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__dynamic_graph_bridge_msgs__srv__RunCommand_Event __attribute__((deprecated))
#else
# define DEPRECATED__dynamic_graph_bridge_msgs__srv__RunCommand_Event __declspec(deprecated)
#endif

namespace dynamic_graph_bridge_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct RunCommand_Event_
{
  using Type = RunCommand_Event_<ContainerAllocator>;

  explicit RunCommand_Event_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_init)
  {
    (void)_init;
  }

  explicit RunCommand_Event_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _info_type =
    service_msgs::msg::ServiceEventInfo_<ContainerAllocator>;
  _info_type info;
  using _request_type =
    rosidl_runtime_cpp::BoundedVector<dynamic_graph_bridge_msgs::srv::RunCommand_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<dynamic_graph_bridge_msgs::srv::RunCommand_Request_<ContainerAllocator>>>;
  _request_type request;
  using _response_type =
    rosidl_runtime_cpp::BoundedVector<dynamic_graph_bridge_msgs::srv::RunCommand_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<dynamic_graph_bridge_msgs::srv::RunCommand_Response_<ContainerAllocator>>>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__info(
    const service_msgs::msg::ServiceEventInfo_<ContainerAllocator> & _arg)
  {
    this->info = _arg;
    return *this;
  }
  Type & set__request(
    const rosidl_runtime_cpp::BoundedVector<dynamic_graph_bridge_msgs::srv::RunCommand_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<dynamic_graph_bridge_msgs::srv::RunCommand_Request_<ContainerAllocator>>> & _arg)
  {
    this->request = _arg;
    return *this;
  }
  Type & set__response(
    const rosidl_runtime_cpp::BoundedVector<dynamic_graph_bridge_msgs::srv::RunCommand_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<dynamic_graph_bridge_msgs::srv::RunCommand_Response_<ContainerAllocator>>> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    dynamic_graph_bridge_msgs::srv::RunCommand_Event_<ContainerAllocator> *;
  using ConstRawPtr =
    const dynamic_graph_bridge_msgs::srv::RunCommand_Event_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dynamic_graph_bridge_msgs::srv::RunCommand_Event_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dynamic_graph_bridge_msgs::srv::RunCommand_Event_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dynamic_graph_bridge_msgs::srv::RunCommand_Event_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dynamic_graph_bridge_msgs::srv::RunCommand_Event_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dynamic_graph_bridge_msgs::srv::RunCommand_Event_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dynamic_graph_bridge_msgs::srv::RunCommand_Event_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dynamic_graph_bridge_msgs::srv::RunCommand_Event_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dynamic_graph_bridge_msgs::srv::RunCommand_Event_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dynamic_graph_bridge_msgs__srv__RunCommand_Event
    std::shared_ptr<dynamic_graph_bridge_msgs::srv::RunCommand_Event_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dynamic_graph_bridge_msgs__srv__RunCommand_Event
    std::shared_ptr<dynamic_graph_bridge_msgs::srv::RunCommand_Event_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RunCommand_Event_ & other) const
  {
    if (this->info != other.info) {
      return false;
    }
    if (this->request != other.request) {
      return false;
    }
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const RunCommand_Event_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RunCommand_Event_

// alias to use template instance with default allocator
using RunCommand_Event =
  dynamic_graph_bridge_msgs::srv::RunCommand_Event_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace dynamic_graph_bridge_msgs

namespace dynamic_graph_bridge_msgs
{

namespace srv
{

struct RunCommand
{
  using Request = dynamic_graph_bridge_msgs::srv::RunCommand_Request;
  using Response = dynamic_graph_bridge_msgs::srv::RunCommand_Response;
  using Event = dynamic_graph_bridge_msgs::srv::RunCommand_Event;
};

}  // namespace srv

}  // namespace dynamic_graph_bridge_msgs

#endif  // DYNAMIC_GRAPH_BRIDGE_MSGS__SRV__DETAIL__RUN_COMMAND__STRUCT_HPP_
