// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from dynamic_graph_bridge_msgs:msg/Matrix.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "dynamic_graph_bridge_msgs/msg/matrix.hpp"


#ifndef DYNAMIC_GRAPH_BRIDGE_MSGS__MSG__DETAIL__MATRIX__STRUCT_HPP_
#define DYNAMIC_GRAPH_BRIDGE_MSGS__MSG__DETAIL__MATRIX__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__dynamic_graph_bridge_msgs__msg__Matrix __attribute__((deprecated))
#else
# define DEPRECATED__dynamic_graph_bridge_msgs__msg__Matrix __declspec(deprecated)
#endif

namespace dynamic_graph_bridge_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Matrix_
{
  using Type = Matrix_<ContainerAllocator>;

  explicit Matrix_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->width = 0ul;
    }
  }

  explicit Matrix_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->width = 0ul;
    }
  }

  // field types and members
  using _data_type =
    std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>>;
  _data_type data;
  using _width_type =
    uint32_t;
  _width_type width;

  // setters for named parameter idiom
  Type & set__data(
    const std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> & _arg)
  {
    this->data = _arg;
    return *this;
  }
  Type & set__width(
    const uint32_t & _arg)
  {
    this->width = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    dynamic_graph_bridge_msgs::msg::Matrix_<ContainerAllocator> *;
  using ConstRawPtr =
    const dynamic_graph_bridge_msgs::msg::Matrix_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dynamic_graph_bridge_msgs::msg::Matrix_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dynamic_graph_bridge_msgs::msg::Matrix_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dynamic_graph_bridge_msgs::msg::Matrix_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dynamic_graph_bridge_msgs::msg::Matrix_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dynamic_graph_bridge_msgs::msg::Matrix_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dynamic_graph_bridge_msgs::msg::Matrix_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dynamic_graph_bridge_msgs::msg::Matrix_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dynamic_graph_bridge_msgs::msg::Matrix_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dynamic_graph_bridge_msgs__msg__Matrix
    std::shared_ptr<dynamic_graph_bridge_msgs::msg::Matrix_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dynamic_graph_bridge_msgs__msg__Matrix
    std::shared_ptr<dynamic_graph_bridge_msgs::msg::Matrix_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Matrix_ & other) const
  {
    if (this->data != other.data) {
      return false;
    }
    if (this->width != other.width) {
      return false;
    }
    return true;
  }
  bool operator!=(const Matrix_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Matrix_

// alias to use template instance with default allocator
using Matrix =
  dynamic_graph_bridge_msgs::msg::Matrix_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace dynamic_graph_bridge_msgs

#endif  // DYNAMIC_GRAPH_BRIDGE_MSGS__MSG__DETAIL__MATRIX__STRUCT_HPP_
